package edu.rutgers.winlab.mfstack.launcher;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;


import android.os.Bundle;
import android.app.Activity;
import android.app.ActivityManager;
import android.app.ActivityManager.RunningServiceInfo;
import android.content.Context;
import android.content.Intent;
import android.content.res.AssetManager;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.EditText;
import android.widget.RadioGroup;
import android.widget.Toast;

/*
 * Activity that launches the stack
 * Initially will only launch it
 * End get the status of the stack
 */

public class LauncherActivity extends Activity {

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_launcher);
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.activity_launcher, menu);
		return true;
	}
	
	public void startStack(View view) throws IOException {
		if(!isServiceRunning()){
			Intent intent = new Intent(this, StackService.class);
			RadioGroup rg = (RadioGroup)findViewById(R.id.radioService);
			int level;
			if(rg.getCheckedRadioButtonId() == R.id.radioQuiet){
				level = 1;
			}
			else{
				level = 2;
			}
			intent.putExtra("DEBUG_LEVEL", level);
			startService(intent);
		}
		else{
			Toast.makeText(this, "Service already running", Toast.LENGTH_SHORT).show();
		}
	}
	
	public void stopStack(View view) throws IOException {
		Intent intent = new Intent(this, StackService.class);
		stopService(intent);
	}
	
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		startActivity(new Intent(this, SettingsActivity.class));
		return super.onOptionsItemSelected(item);
	}

	public void logStack(View view) throws IOException {
		Toast.makeText(this, "Function not yet implemented", Toast.LENGTH_SHORT).show();
		//Intent intent = new Intent(this, LogStatusActivity.class);
		//startService(intent);
	}
	
	public void installStack(View view) throws IOException {
		Toast.makeText(this, "Function not yet implemented", Toast.LENGTH_SHORT).show();
		/*Process p = null;
		try {
			p = Runtime.getRuntime().exec("su");
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		copyAssets();
		try {
			DataOutputStream os = new DataOutputStream(p.getOutputStream());
			os.writeBytes("exit\n");  
			os.flush();
			p.waitFor();
			os.close();
		if (p.exitValue() != 255) {  
			// TODO Code to run on success  
			System.out.println("Everything perfect");
		}  
		else {
			System.out.println("Error somewhere");
		}  
		} catch (InterruptedException e) {
			System.out.println(e.getMessage());
		}*/
	}
	
	private boolean isServiceRunning() {
		ActivityManager manager = (ActivityManager) getSystemService(Context.ACTIVITY_SERVICE);
		for (RunningServiceInfo service : manager.getRunningServices(Integer.MAX_VALUE)) {
			if (StackService.class.getName().equals(service.service.getClassName())) {
				return true;
			}
		}
		return false;
	}
	
	private void copyAssets() {
		//copyFile("","/data/mfdemo/");
		//copyFile("","/data/mfdemo/");
		copyFile("libgnustl_shared.so","/system/lib/");
		copyFile("libpcap.so","/system/lib/");
		copyFile("libmfapi.so","/system/lib/");
		copyFile("mfandroidstack","/system/bin/");
	}
	
	private void copyFile(String fileName, String destFolder){
		byte[] buffer = new byte[1024];
		int read;
		AssetManager assetManager = getAssets();
		InputStream in = null;
		OutputStream out = null;
		try {
			in = assetManager.open(fileName);
			out = new FileOutputStream(destFolder + fileName);
			while((read = in.read(buffer)) != -1){
				out.write(buffer, 0, read);
			}
			in.close();
			out.flush();
			out.close();
		} catch (IOException e) {
			System.out.println("Failed to copy asset file: " + e.getMessage());
		}
	}

}
